#!/usr/bin/perl

use SOAP::Lite;

package HPSMSOAP;
require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(soapdata soapfault soapstatus);

sub soapdata {
    my ($som, $root, $num) = @_;
    sdindent($som, $root, $num, 0);
}

# private implementation
sub sdindent {
    my ($som, $root, $num, $indent) = @_;
    my $ref = $som->valueof($root);
    my @keys = sort(keys(%$ref));
    my $indstr = ' ' x int($indent);
    foreach my $k (@keys) {
	my $count = 0;
	foreach my $v ($som->valueof("$root/$k")) {
	    my $kk = $k;
	    $count += 1;
	    given ($v) {
		when(undef) {
		    $kk .= "[$count]" if ($num);
		    print "$indstr$kk: (undefined)\n";
		}
		when(ref($_) eq 'HASH') {
		    print "$indstr$kk: (\n";
		    sdindent($som, "$root/$k", 1, $indent + 2);
		    print "$indstr$kk: )\n";
		}
		when ('') {
		    $kk .= "[$count]" if ($num);
		    print "$indstr$kk: (empty)\n";
		}
		default {
		    $kk .= "[$count]" if ($num);
		    my @ls = split(/\n/, $v);
		    my $lcount = 0;
		    foreach my $l (@ls) {
			$lcount += 1;
			$kk .= "($lcount)" if ($#ls > 0);
			print "$indstr$kk: $l\n";
			$kk =~ s/\(\d+\)$//;
		    }
		}
	    }
	}
    }
}

sub soapfault {
    my $som = $_[0];
    if ($som->fault) {
	my $code = $som->faultcode;
	my $actor = $som->faultactor;
	my $string = $som->faultstring;
	my $detail = $som->faultdetail;
	my $out = "Fault\n";
	$out .= "\tCode\t$code\n" if ($code);
	$out .= "\tActor\t$actor\n" if ($actor);
	$out .= "\tString\t$string\n" if ($string);
	$out .= "\tDetail\t$detail\n" if ($detail);
	die $out;
    }
}

sub soapstatus {
    my ($som) = @_;
    my $attr = $som->dataof('/Envelope/Body/[1]')->attr;
    my $status = $attr->{'status'};
    my $message = $attr->{'message'};
    print "SOAP $status: $message\n";
}

1;
